module GenderMachine
  class Predictor
    include Anima.new(:name)

    NULL_NAME = OpenStruct.new(gender: "",
                                name: "",
                                frequency_string: "",
                                raw: "")
    def name_match_block
      ->(obj){ obj.name == name }
    end

    def ensure_default_response(default)
      response = yield
      response || default
    end

    def find(name = name)
      Core::NAMES.select(&name_match_block)
    end

    def first(name = name)
      ensure_default_response(NULL_NAME) do
        Core::NAMES.detect(&name_match_block)
      end
    end

    def where
      # TODO:
    end
  end
end
